<?php
if (!class_exists('SpeedyCache')) {
class SpeedyCache
{
    CONST PATH = _PS_MODULE_DIR_ . Speedy::MODULE_NAME . DIRECTORY_SEPARATOR . 'classes' . DIRECTORY_SEPARATOR . 'cache' . DIRECTORY_SEPARATOR;
    CONST EXPIRE = 3600; // 1 hour

    static function clean() {
        $files = glob(SpeedyCache::PATH . 'cache.*');

        if ($files) {
            foreach ($files as $file) {
                $time = substr(strrchr($file, '.'), 1);

                if ($time < time()) {
                    if (file_exists($file)) {
                        unlink($file);
                    }
                }
            }
        }
    }

    static function get($key) {
        $files = glob(SpeedyCache::PATH . 'cache.' . preg_replace('/[^A-Z0-9\._-]/i', '', $key) . '.*');

        if ($files) {
            $handle = fopen($files[0], 'r');

            flock($handle, LOCK_SH);

            $data = fread($handle, filesize($files[0]));

            flock($handle, LOCK_UN);

            fclose($handle);

            return unserialize($data);
        }

        return false;
    }

    static function set($key, $value) {
        self::delete($key);

        $file = SpeedyCache::PATH . 'cache.' . preg_replace('/[^A-Z0-9\._-]/i', '', $key) . '.' . (time() + SpeedyCache::EXPIRE);

        $handle = fopen($file, 'w');

        flock($handle, LOCK_EX);

        fwrite($handle, serialize($value));

        fflush($handle);

        flock($handle, LOCK_UN);

        fclose($handle);
    }

    static function delete($key) {
        $files = glob(SpeedyCache::PATH . 'cache.' . preg_replace('/[^A-Z0-9\._-]/i', '', $key) . '.*');

        if ($files) {
            foreach ($files as $file) {
                if (file_exists($file)) {
                    unlink($file);
                }
            }
        }
    }
}
}